﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Linq.Expressions;

namespace GodHand.Infrastructure.Repository
{
    public interface IRepository<T> : IQueryable<T> where T : class, new()
    {
        IRepository<T> AsTableName(string tableName);
        IRepository<T> AsNoLock();
        IRepository<T> AsNoTracking();
        T CreateModel();
        bool New(T entity, bool INSERT_IDENTITY = false);
        bool Update(T entity);
        void Update(Expression<Func<T, bool>> exp, object obj);
        bool Delete(T t);
        void Delete(Expression<Func<T, bool>> exp);
        bool VirtualDelete(T t);
        Guid NewGuid();
        decimal NewId();
    }
}
