﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections;
using System.Runtime.Serialization;
using System.Xml.Serialization;

namespace GodHand.Infrastructure.Repository
{
    [Serializable]
    public class PageResult<T> : IPageResult
    {
        public int TotalCount { get; set; }
        public List<T> List { get; set; }

        IEnumerable IPageResult.List
        {
            get
            {
                return this.List;
            }
            set
            {
                this.List = value as List<T>;
            }
        }
        public PageResult<U> CopyConvert<U>() where U:class,new()
        {
            var list = new List<U>();
            if (this.List != null)
            {
                this.List.ForEach((c) =>
                {
                    list.Add(c.CopyConvert<U>());
                });
            }
            return new PageResult<U> { List = list, TotalCount = this.TotalCount };
        }
    }
    [Serializable]
    public class PageResult : IPageResult
    {
        public int TotalCount { get; set; }
        public IEnumerable List { get; set; }
    }
    public interface IPageResult
    {
        int TotalCount { get; set; }
        IEnumerable List { get; set; }
    }
}
