﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections.Specialized;

namespace GodHand.Infrastructure.Repository
{
    internal class RepositoryContextConfiguration
    {
        static List<RepositoryContextElement> contextElementList = null;
        public static RepositoryContextElement GetContextConfiguration(string name)
        {
            if (contextElementList == null) { InitConfiguration(); }
            return contextElementList.FirstOrDefault(c => c.Name == name);
        }
        static void InitConfiguration()
        {
            contextElementList = ConfigurationManagerHelper.GetSection<List<RepositoryContextElement>>("RepositoryContext");
        }
    }
    class RepositoryContextElement
    {
        string[] paramValues = null;
        public string Name { get; set; }
        public string ContextType { get; set; }
        public string RepositoryType { get; set; }
        public NameValueCollection Params { get; set; }
        public string[] GetParamValues()
        {
            if (paramValues == null)
            {
                List<string> ps = new List<string>();
                foreach (string k in this.Params.Keys)
                {
                    ps.Add(this.Params[k]);
                }
                paramValues = ps.ToArray();
            }
            return paramValues;
        }
    }
}
