﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml;
using System.Collections.Specialized;

namespace GodHand.Infrastructure.Repository
{
    class RepositoryContextSectionHandler : AbstractSerializerSectionHandler
    {
        public override object Create(object parent, object configContext, System.Xml.XmlNode section)
        {
            var contextElementList = new List<RepositoryContextElement>();
            var contextNodes = section.SelectNodes("Context");
            foreach (XmlNode cnode in contextNodes)
            {
                var ce = new RepositoryContextElement();
                ce.Name = GetAttributeValue("Name", cnode);
                ce.ContextType = GetAttributeValue("ContextType", cnode);
                ce.RepositoryType = GetAttributeValue("RepositoryType", cnode);
                var paramsNodes = cnode.SelectNodes("Param");
                ce.Params = new NameValueCollection();
                foreach (XmlNode paramNode in paramsNodes)
                {
                    ce.Params.Add(GetAttributeValue("Name", paramNode), GetAttributeValue("Value", paramNode));
                }
                contextElementList.Add(ce);
            }
            return contextElementList;
        }
    }
}
